// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package shop

import (
	"context"
	"errors"
	"time"

	"juwan-backend/app/shop/api/internal/svc"
	"juwan-backend/app/shop/api/internal/types"
	"juwan-backend/app/shop/rpc/pb"
	"juwan-backend/common/utils/contextj"

	"github.com/zeromicro/go-zero/core/logx"
)

type RemovePlayerLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// 移除打手
func NewRemovePlayerLogic(ctx context.Context, svcCtx *svc.ServiceContext) *RemovePlayerLogic {
	return &RemovePlayerLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *RemovePlayerLogic) RemovePlayer(req *types.RemovePlayerReq) (resp *types.EmptyResp, err error) {
	userID, err := contextj.UserIDFrom(l.ctx)
	if err != nil {
		return nil, err
	}

	shop, err := l.svcCtx.ShopRpc.GetShopsById(l.ctx, &pb.GetShopsByIdReq{Id: req.Id})
	if err != nil {
		return nil, err
	}
	if shop.Shops == nil {
		return nil, errors.New("shop not found")
	}
	if shop.Shops.OwnerId != userID {
		return nil, contextj.ERRILLEGALUSER
	}

	_, err = l.svcCtx.ShopRpc.UpdateShopPlayers(l.ctx, &pb.UpdateShopPlayersReq{
		ShopId:    req.Id,
		PlayerId:  req.PlayerId,
		IsPrimary: false,
		LeftAt:    time.Now().Unix(),
	})
	if err != nil {
		return nil, err
	}

	return &types.EmptyResp{}, nil
}
